#include "data_type.h"

using namespace graph_data;

Node::Node(const QString& name) : _point_name(name) { }

QString Node::name() const {
	return _point_name;
}

Line::Line(const Node& _p0, const Node& _p1) :_p0(_p0), _p1(_p1) {}

Line::Line(const QString& n0, const QString& n1) :
	Line(Node(n0), Node(n1)) {}

QList<Node> Line::points() const {
	return QList<Node>{this->_p0, this->_p1};
}

Arrow::Arrow(const Node& s, const Node& e) : Line(s, e) {}

Arrow::Arrow(const QString& s, const QString& e) : Line(s, e) {}

Node Arrow::startPoint() const {
	return this->points()[0];
}

Node Arrow::endPoint() const {
	return this->points()[1];
}
