#pragma once

#include "libparse_global.h"
#include <ast_basic.h>
#include <ast_gen.h>

namespace lib_parse {
    /**
     * @brief 쳣
     */
    class LIBPARSE_EXPORT CheckException {
    private:
        QString msg_store;

    public:
        CheckException(const QString& msg);
        virtual ~CheckException() = default;

        virtual QString message() const;
    };


    /**
     * @brief Уṩ
     */
    class CheckProvider {
    public:
        virtual QString name() const = 0;
        virtual void validCheck(std::shared_ptr<const ast_gen::ElementAccess> root) const = 0;
    };


    /**
     * @brief ӿ
     */
    class LIBPARSE_EXPORT Analyzer {
    private:
        QList<std::shared_ptr<const CheckProvider>> check_providers;

    public:
        Analyzer(const QList<std::shared_ptr<const CheckProvider>>& providers);

        std::shared_ptr<const ast_gen::ElementAccess> validCheckWith(std::shared_ptr<const ast_gen::ElementAccess> root) const;
    };

    enum class VisitMode {
        FirstParent,    // 
        LastParent,     // 
    };

    class TreeVisitor {
    public:
        /**
         * ȡıģʽ.
         * 
         * \return 
         */
        virtual VisitMode mode() const = 0;

        /**
         * ﷨ִнڵ.
         * 
         * \param syntax_element ǰʽڵ
         * \return Ƿִб
         */
        virtual bool visit(std::shared_ptr<const ast_gen::ElementAccess> syntax_element) = 0;
    };

    class LIBPARSE_EXPORT VisitorControl {
    public:
        bool visitWith(std::shared_ptr<const ast_gen::ElementAccess> syntax_elm, std::shared_ptr<TreeVisitor> visitor);
    };
}
